/* gcc gdbhelper.c -o gdbhelper -Wall */

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/wait.h>

int main(int argc, char *argv[])
{
	pid_t pid = fork();
	char path[1024], cmd[1024];
	int fd_in[2], fd_log, status;

	switch (pid) {
	case 1:
		perror("fork()");
		return 1;
	case 0:
		/* child */
		execvp(argv[1], argv+1);
		return 2;
	default:
		snprintf(path, sizeof(path), "/tmp/gdbhelper.%lu.%u",
			 (unsigned long)time(NULL), (unsigned int)pid);
		fd_log = open(path, O_CREAT | O_WRONLY, 0600);
		if (fd_log < 0) {
			perror("open()");
			return 4;
		}
		if (pipe(fd_in) < 0) {
			perror("pipe()");
			return 3;
		}
		write(fd_in[1], "cont\nwhere\nquit\n", 16);
		dup2(fd_in[0], 0);
		dup2(fd_log, 1);
		dup2(fd_log, 2);
		snprintf(cmd, sizeof(cmd), "gdb %s %u",
			 argv[1], (unsigned int)pid);
		system(cmd);

		wait(&status);
		if (status == 0)
			unlink(path);
	}
	return 0;
}
